/********************************

		タッチパネル

 ********************************/

#ifndef	___TOUCH_PANEL_H___
#define	___TOUCH_PANEL_H___

#include "common.h"


namespace sys
{

/**********************
    タッチパネル管理
 **********************/
class TouchManager
{
public :

	static void		init_manager(void);					// 管理システム初期化
	static void		quit_manager(void);					// 管理システム終了
	static void		update_manager(short const*);		// 管理システム稼働

private :

	int		repeat_cnt;			// リピート用カウンタ
	int		prev_x, prev_y;		// 前回のタッチ位置

public :

static const int	TOUCH_MAX = 5;						// マルチタッチ数

enum
{
	TOUCH	= (1 << 0),			// タッチ
	TRIGGER	= (1 << 1),			// 初回タッチ
	TRIG	= TRIGGER,
	REPEAT	= (1 << 2),			// リピート
	RELEASE	= (1 << 3),			// リリース
};

	u32		flag;				// タッチ状態フラグ
	int		x, y;				// タッチ位置
	int		move_x, move_y;		// 移動距離

		TouchManager(void)				// コンストラクタ
		{
			flag = 0x00;
		}
	void	update(short const*);		// 稼働
};

extern TouchManager*	TouchPanel;

}

#endif
/*************** End of File ****************************************/
